Website to Text API
============

Website to Text is a simple tool for converting a website to text. It returns the text extracted from the website.

![Build Status](https://img.shields.io/badge/build-passing-green)
![Code Climate](https://img.shields.io/badge/maintainability-B-purple)
![Prod Ready](https://img.shields.io/badge/production-ready-blue)

This is a Python API Wrapper for the [Website to Text API](https://apiverve.com/marketplace/api/websitetotext)

---

## Installation
	pip install apiverve-websitetotext

---

## Configuration

Before using the websitetotext API client, you have to setup your account and obtain your API Key.  
You can get it by signing up at [https://apiverve.com](https://apiverve.com)

---

## Usage

The Website to Text API documentation is found here: [https://docs.apiverve.com/api/websitetotext](https://docs.apiverve.com/api/websitetotext).  
You can find parameters, example responses, and status codes documented here.

### Setup

```
# Import the client module
from apiverve_websitetotext.apiClient import WebsitetotextAPIClient

# Initialize the client with your APIVerve API key
api = WebsitetotextAPIClient("[YOUR_API_KEY]")
```

---


### Perform Request
Using the API client, you can perform requests to the API.

###### Define Query

```
query = {  "url": "https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts" }
```

###### Simple Request

```
# Make a request to the API
result = api.execute(query)

# Print the result
print(result)
```

###### Example Response

```
{
  "status": "ok",
  "error": null,
  "data": {
    "date": null,
    "description": "Use Amazon EC2 for scalable computing capacity in the AWS Cloud so you can develop and deploy applications without hardware constraints.",
    "title": "What is Amazon EC2?",
    "title_alt": "What is Amazon EC2?",
    "text": "Amazon Elastic Compute Cloud (Amazon EC2) provides on-demand, scalable computing capacity in the Amazon Web \t\tServices (AWS) Cloud. Using Amazon EC2 reduces hardware costs so you can develop and deploy \t\tapplications faster. You can use Amazon EC2 to launch as many or as few virtual servers as you \t\tneed, configure security and networking, and manage storage. You can add capacity (scale up) \t\tto handle compute-heavy tasks, such as monthly or yearly processes, or spikes in website \t\ttraffic. When usage decreases, you can reduce capacity (scale down) again.  The following diagram shows a basic architecture of an Amazon EC2 instance deployed within an \t\tAmazon Virtual Private Cloud (VPC). In this example, the EC2 instance is within an Availability Zone in the \t\tRegion. The EC2 instance is secured with a security group, which is a virtual firewall that \t\tcontrols incoming and outgoing traffic. A private key is stored on the local computer and a \t\tpublic key is stored on the instance. Both keys are specified as a key pair to prove the \t\tidentity of the user. In this scenario, the instance is backed by an Amazon EBS volume. The VPC \t\tcommunicates with the internet using an internet gateway. For more information about Amazon VPC, \t\tsee the Amazon VPC User Guide.  Amazon EC2 supports the processing, storage, and transmission  of credit card data by a merchant or service provider, and has been  validated as being compliant with Payment Card Industry (PCI) Data Security Standard (DSS).  For more information about PCI DSS, including how to request a copy of the AWS PCI Compliance Package,  see PCI DSS Level 1.  If you are looking for technical guidance about Amazon EC2, try AWS re:Post.  For more information about cloud computing, see What is cloud computing?  Amazon EC2 provides the following high-level features:  For details about all of the features of Amazon EC2, see Amazon EC2 features.  For options to run your website on AWS, see Web Hosting.  The following topics can help you get started with Amazon EC2. After you set up to use EC2, you \t\t\tcan walk through Tutorial: Get started with Amazon EC2 Linux  instances to \t\t\tlaunch, connect to, and clean up an instance. The remaining topics point to more \t\t\tinformation about the high-level features of EC2.  You can create and manage your Amazon EC2 instances using the following interfaces:  Amazon EC2 provides the following pricing options:  For a complete list of charges and prices for Amazon EC2 and more information about the purchase \t\t\tmodels, see Amazon EC2 pricing.  To create estimates for your AWS use cases, use the AWS Pricing Calculator.  To see your bill, go to the Billing and Cost Management  Dashboard in the AWS Billing and Cost Management  console. Your bill contains links to usage reports that provide details \t\t\t\tabout your bill. To learn more about AWS account billing, see AWS Billing and Cost Management User  Guide.  If you have questions concerning AWS billing, accounts, and events, contact AWS Support.  To calculate the cost of a sample provisioned \t\t\t\t\tenvironment, see . When calculating the cost of a provisioned \t\t\t\tenvironment, remember to include incidental costs such as snapshot storage for EBS \t\t\t\tvolumes.  You can optimize the cost, security, and performance of your AWS environment \t\t\t\tusing AWS Trusted Advisor.",
    "language": "en",
    "url": "<!DOCTYPE html>\n    <html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en-US\"><head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><title>What is Amazon EC2? - Amazon Elastic Compute Cloud</title><meta name=\"viewport\" content=\"width=device-width,initial-scale=1\" /><meta name=\"assets_root\" content=\"/assets\" /><meta name=\"target_state\" content=\"concepts\" /><meta name=\"default_state\" content=\"concepts\" /><link rel=\"icon\" type=\"image/ico\" href=\"/assets/images/favicon.ico\" /><link rel=\"shortcut icon\" type=\"image/ico\" href=\"/assets/images/favicon.ico\" /><link rel=\"canonical\" href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\" /><meta name=\"description\" content=\"Use Amazon EC2 for scalable computing capacity in the AWS Cloud so you can develop and deploy applications without hardware constraints.\" /><meta name=\"deployment_region\" content=\"IAD\" /><meta name=\"product\" content=\"Amazon Elastic Compute Cloud\" /><meta name=\"guide\" content=\"User Guide for Linux Instances\" /><meta name=\"abstract\" content=\"Use Amazon EC2 to configure, launch, and manage virtual servers in the AWS cloud.\" /><meta name=\"guide-locale\" content=\"en_us\" /><meta name=\"tocs\" content=\"toc-contents.json\" /><link rel=\"canonical\" href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/id_id/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"id-id\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/id_id/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"id\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/de_de/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"de-de\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/de_de/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"de\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"en-us\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"en\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/es_es/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"es-es\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/es_es/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"es\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/fr_fr/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"fr-fr\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/fr_fr/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"fr\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/it_it/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"it-it\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/it_it/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"it\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/ja_jp/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"ja-jp\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/ja_jp/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"ja\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/ko_kr/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"ko-kr\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/ko_kr/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"ko\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/pt_br/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"pt-br\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/pt_br/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"pt\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/zh_cn/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"zh-cn\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/zh_tw/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"zh-tw\" /><link rel=\"alternative\" href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\" hreflang=\"x-default\" /><meta name=\"feedback-item\" content=\"EC2\" /><meta name=\"this_doc_product\" content=\"Amazon Elastic Compute Cloud\" /><meta name=\"this_doc_guide\" content=\"User Guide for Linux Instances\" /><script defer=\"\" src=\"/assets/r/vendor4.js?version=2021.12.02\"></script><script defer=\"\" src=\"/assets/r/vendor3.js?version=2021.12.02\"></script><script defer=\"\" src=\"/assets/r/vendor1.js?version=2021.12.02\"></script><script defer=\"\" src=\"/assets/r/awsdocs-common.js?version=2021.12.02\"></script><script defer=\"\" src=\"/assets/r/awsdocs-doc-page.js?version=2021.12.02\"></script><link href=\"/assets/r/vendor4.css?version=2021.12.02\" rel=\"stylesheet\" /><link href=\"/assets/r/awsdocs-common.css?version=2021.12.02\" rel=\"stylesheet\" /><link href=\"/assets/r/awsdocs-doc-page.css?version=2021.12.02\" rel=\"stylesheet\" /><script async=\"\" id=\"awsc-panorama-bundle\" type=\"text/javascript\" src=\"https://prod.pa.cdn.uis.awsstatic.com/panorama-nav-init.js\" data-config=\"{'appEntity':'aws-documentation','region':'us-east-1','service':'ec2'}\"></script><meta id=\"panorama-serviceSubSection\" value=\"User Guide for Linux Instances\" /><meta id=\"panorama-serviceConsolePage\" value=\"What is Amazon EC2?\" /></head><body class=\"awsdocs awsui\"><div class=\"awsdocs-container\"><awsdocs-header></awsdocs-header><awsui-app-layout id=\"app-layout\" class=\"awsui-util-no-gutters\" ng-controller=\"ContentController as $ctrl\" header-selector=\"awsdocs-header\" navigation-hide=\"false\" navigation-width=\"$ctrl.navWidth\" navigation-open=\"$ctrl.navOpen\" navigation-change=\"$ctrl.onNavChange($event)\" tools-hide=\"$ctrl.hideTools\" tools-width=\"$ctrl.toolsWidth\" tools-open=\"$ctrl.toolsOpen\" tools-change=\"$ctrl.onToolsChange($event)\"><div id=\"guide-toc\" dom-region=\"navigation\"><awsdocs-toc></awsdocs-toc></div><div id=\"main-column\" dom-region=\"content\" tabindex=\"-1\"><awsdocs-view class=\"awsdocs-view\"><div id=\"awsdocs-content\"><head><title>What is Amazon EC2? - Amazon Elastic Compute Cloud</title><meta name=\"pdf\" content=\"/pdfs/AWSEC2/latest/UserGuide/ec2-ug.pdf#concepts\" /><meta name=\"rss\" content=\"amazon-ec2-release-notes.rss\" /><meta name=\"forums\" content=\"http://forums.aws.amazon.com/forum.jspa?forumID=30\" /><meta name=\"feedback\" content=\"https://docs.aws.amazon.com/forms/aws-doc-feedback?hidden_service_name=EC2&amp;topic_url=https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/concepts.html\" /><meta name=\"feedback-yes\" content=\"feedbackyes.html?topic_url=https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/concepts.html\" /><meta name=\"feedback-no\" content=\"feedbackno.html?topic_url=https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/concepts.html\" /><meta name=\"keywords\" content=\"EC2,Amazon EC2,EC2 instance,instance,VM,virtual machine\" /><script type=\"application/ld+json\">\n{\n    \"@context\" : \"https://schema.org\",\n    \"@type\" : \"BreadcrumbList\",\n    \"itemListElement\" : [\n      {\n        \"@type\" : \"ListItem\",\n        \"position\" : 1,\n        \"name\" : \"AWS\",\n        \"item\" : \"https://aws.amazon.com\"\n      },\n      {\n        \"@type\" : \"ListItem\",\n        \"position\" : 2,\n        \"name\" : \"Amazon EC2\",\n        \"item\" : \"https://docs.aws.amazon.com/ec2/index.html\"\n      },\n      {\n        \"@type\" : \"ListItem\",\n        \"position\" : 3,\n        \"name\" : \"User Guide for Linux Instances\",\n        \"item\" : \"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide\"\n      },\n      {\n        \"@type\" : \"ListItem\",\n        \"position\" : 4,\n        \"name\" : \"What is Amazon EC2?\",\n        \"item\" : \"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/concepts.html\"\n      }\n    ]\n}\n</script></head><body><div id=\"main\"><div style=\"display: none\"><a href=\"/pdfs/AWSEC2/latest/UserGuide/ec2-ug.pdf#concepts\" target=\"_blank\" rel=\"noopener noreferrer\" title=\"Open PDF\"></a></div><div id=\"breadcrumbs\" class=\"breadcrumb\"><a href=\"https://aws.amazon.com\">AWS</a><a href=\"/index.html\">Documentation</a><a href=\"/ec2/index.html\">Amazon EC2</a><a href=\"concepts.html\">User Guide for Linux Instances</a></div><div id=\"page-toc-src\"><a href=\"#ec2-features\">Features</a><a href=\"#how-to-get-started\">Get started</a><a href=\"#related-services\">Related services</a><a href=\"#access-ec2\">Access EC2</a><a href=\"#ec2-pricing\">Pricing</a></div><awsdocs-doc-page-banner></awsdocs-doc-page-banner><div id=\"main-content\" class=\"awsui-util-container\"><div id=\"main-col-body\"><awsdocs-language-banner data-service=\"$ctrl.pageService\"></awsdocs-language-banner><h1 class=\"topictitle\" id=\"concepts\">What is Amazon EC2?</h1><div class=\"awsdocs-page-header-container\"><awsdocs-page-header></awsdocs-page-header><awsdocs-filter-selector id=\"awsdocs-filter-selector\"></awsdocs-filter-selector></div><p>Amazon Elastic Compute Cloud (Amazon EC2) provides on-demand, scalable computing capacity in the Amazon Web\n\t\tServices (AWS) Cloud. Using Amazon EC2 reduces hardware costs so you can develop and deploy\n\t\tapplications faster. You can use Amazon EC2 to launch as many or as few virtual servers as you\n\t\tneed, configure security and networking, and manage storage. You can add capacity (scale up)\n\t\tto handle compute-heavy tasks, such as monthly or yearly processes, or spikes in website\n\t\ttraffic. When usage decreases, you can reduce capacity (scale down) again.</p><p>The following diagram shows a basic architecture of an Amazon EC2 instance deployed within an\n\t\tAmazon Virtual Private Cloud (VPC). In this example, the EC2 instance is within an Availability Zone in the\n\t\tRegion. The EC2 instance is secured with a security group, which is a virtual firewall that\n\t\tcontrols incoming and outgoing traffic. A private key is stored on the local computer and a\n\t\tpublic key is stored on the instance. Both keys are specified as a key pair to prove the\n\t\tidentity of the user. In this scenario, the instance is backed by an Amazon EBS volume. The VPC\n\t\tcommunicates with the internet using an internet gateway. For more information about Amazon VPC,\n\t\tsee the <a href=\"https://docs.aws.amazon.com/vpc/latest/userguide/\">Amazon VPC User Guide</a>.</p><div class=\"mediaobject\">\n\t\t \n\t\t\t<img src=\"/images/AWSEC2/latest/UserGuide/images/ec2-basic-arch.png\" class=\"aws-docs-img-whiteBg aws-docs-img-padding\" alt=\"A basic architecture diagram of an EC2 instance within a VPC.\" style=\"max-width:100%\" />\n\t\t \n\t\t \n\t</div><div class=\"awsdocs-note awsdocs-tip\"><div class=\"awsdocs-note-title\"><awsui-icon name=\"status-info\" variant=\"link\"></awsui-icon><h6>Tip</h6></div><div class=\"awsdocs-note-text\"><p>This user guide provides information specific to running Linux-based instances on\n\t\t\tAmazon EC2. See the <a href=\"https://docs.aws.amazon.com/AWSEC2/latest/WindowsGuide/concepts.html\">EC2 User Guide for Windows\n\t\t\t\tInstances</a> for information to help you run Windows-based instances on\n\t\t\tEC2.</p></div></div><p>Amazon EC2 supports the processing, storage, and transmission \nof credit card data by a merchant or service provider, and has been \nvalidated as being compliant with Payment Card Industry (PCI) Data Security Standard (DSS). \nFor more information about PCI DSS, including how to request a copy of the AWS PCI Compliance Package, \nsee <a href=\"https://aws.amazon.com/compliance/pci-dss-level-1-faqs/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>PCI DSS Level 1</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.\n</p><p>If you are looking for technical guidance about Amazon EC2, try <a href=\"https://repost.aws/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>AWS re:Post</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p><p>For more information about cloud computing, see <a href=\"https://aws.amazon.com/what-is-cloud-computing/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>What is cloud computing?</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a></p>\n\t\t<h2 id=\"ec2-features\">Features of Amazon EC2</h2>\n\n\t\t<p>Amazon EC2 provides the following high-level features:</p>\n\n\t\t<div class=\"variablelist\">\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t<dl>\n\t\t\t\t<dt><b><span class=\"term\">Instances</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Virtual servers.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Amazon Machine Images (AMIs)</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Preconfigured templates for your instances that package the components you\n\t\t\t\t\t\tneed for your server (including the operating system and additional\n\t\t\t\t\t\tsoftware).</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Instance types</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Various configurations of CPU, memory, storage, networking capacity, and\n\t\t\t\t\t\tgraphics hardware for your instances.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Key pairs</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Secure login information for your instances. AWS stores the public key\n\t\t\t\t\t\tand you store the private key in a secure place.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Instance store volumes</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Storage volumes for temporary data that is deleted when you stop,\n\t\t\t\t\t\thibernate, or terminate your instance.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Amazon EBS volumes</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Persistent storage volumes for your data using Amazon Elastic Block Store (Amazon EBS).</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Regions and Zones</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Multiple physical locations for your resources, such as instances and\n\t\t\t\t\t\tAmazon EBS volumes.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Security groups</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>A virtual firewall that allows you to specify the protocols, ports, and\n\t\t\t\t\t\tsource IP ranges that can reach your instances, and the destination IP\n\t\t\t\t\t\tranges to which your instances can connect. </p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Elastic IP addresses</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Static IPv4 addresses for dynamic cloud computing.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Tags</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Metadata that you can create and assign to your Amazon EC2 resources.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Virtual private clouds (VPCs)</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Virtual networks you can create that are logically isolated from the rest\n\t\t\t\t\t\tof the AWS Cloud. You can optionally connect these virtual networks to\n\t\t\t\t\t\tyour own network.</p>\n\t\t\t\t</dd>\n\t\t\t</dl></div>\n\n\t\t<p>For details about all of the features of Amazon EC2, see <a href=\"https://aws.amazon.com/ec2/features\" rel=\"noopener noreferrer\" target=\"_blank\"><span>Amazon EC2 features</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>. </p>\n\n\t\t<p>For options to run your website on AWS, see <a href=\"https://aws.amazon.com/websites/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>Web Hosting</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\n\t \n\t\t<h2 id=\"how-to-get-started\">Get started with Amazon EC2</h2>\n\n\t\t<p>The following topics can help you get started with Amazon EC2. After you set up to use EC2, you\n\t\t\tcan walk through <a href=\"./EC2_GetStarted.html\">Tutorial: Get started with Amazon EC2 Linux\n\t\t\tinstances</a> to\n\t\t\tlaunch, connect to, and clean up an instance. The remaining topics point to more\n\t\t\tinformation about the high-level features of EC2. </p>\n\n\t\t<div class=\"itemizedlist\">\n\t\t\t<h6>Set up and use an EC2 instance</h6>\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t\n\t\t\t \n\t\t\t\n\t\t<ul class=\"itemizedlist\"><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./get-set-up-for-amazon-ec2.html\">Set up to use Amazon EC2</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./EC2_GetStarted.html\">Tutorial: Get started with Amazon EC2 Linux\n\t\t\tinstances</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/connect-to-linux-instance.html\">Connect to your Linux\n\t\t\t\t\t\tinstance</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./connect-linux-inst-ssh.html#linux-file-transfer-scp\">Transfer\n\t\t\t\t\tfiles</a></p>\n\t\t\t</li></ul></div>\n\t\t<div class=\"itemizedlist\">\n\t\t\t<h6>Learn the basics of Amazon EC2</h6>\n\t\t\t \n\t\t\t\n\t\t\t \n\t\t\t \n\t\t<ul class=\"itemizedlist\"><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./ec2-instances-and-amis.html\">Instances and AMIs</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./using-regions-availability-zones.html\">Regions and Zones</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./instance-types.html\">Amazon EC2 instance types</a></p>\n\t\t\t</li></ul></div>\n\t\t<div class=\"itemizedlist\">\n\t\t\t<h6>Read about networking and security</h6>\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t<ul class=\"itemizedlist\"><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./ec2-key-pairs.html\">Key pairs</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./ec2-security-groups.html\">Security groups</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./elastic-ip-addresses-eip.html\">Elastic IP addresses</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./using-vpc.html\">Virtual private clouds</a></p>\n\t\t\t</li></ul></div>\n\t\t<div class=\"itemizedlist\">\n\t\t\t<h6>Review your storage options</h6>\n\t\t\t \n\t\t\t \n\t\t<ul class=\"itemizedlist\"><li class=\"listitem\">\n\t\t\t\t<p><a href=\"https://docs.aws.amazon.com/ebs/latest/userguide/\">Amazon EBS</a></p>\n\t\t\t</li><li class=\"listitem\">\n\t\t\t\t<p><a href=\"./InstanceStorage.html\">Instance store</a></p>\n\t\t\t</li></ul></div>\n\t \n\t\t<h2 id=\"related-services\">Related services</h2>\n\n\t\t<div class=\"variablelist\">\n\t\t\t<h6>Services to use with Amazon EC2</h6>\n\t\t\t<p>You can use other AWS services with the instances that you deploy using Amazon EC2.</p>\n        \t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n        <dl>\n        \t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/autoscaling\">Amazon EC2 Auto Scaling</a></span></dt>\n        \t\t<dd>\n        \t\t\t<p>Helps ensure you have the correct number of Amazon EC2 instances available to\n        \t\t\t\thandle the load for your application.</p>\n        \t\t</dd>\n        \t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/aws-backup\">AWS Backup</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Automate backing up your Amazon EC2 instances and the Amazon EBS volumes attached to\n\t\t\t\t\t\tthem.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/cloudwatch\">Amazon CloudWatch</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Monitor your instances and Amazon EBS volumes.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/elasticloadbalancing\">Elastic Load Balancing</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Automatically distribute incoming application traffic across multiple\n\t\t\t\t\t\tinstances.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/guardduty\">Amazon GuardDuty</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Detect potentially unauthorized or malicious use of your EC2 instances.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/imagebuilder\">EC2 Image Builder</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Automate the creation, management, and deployment of customized, secure, and\n\t\t\t\t\t\tup-to-date server images.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/launchwizard\">AWS Launch Wizard</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Size, configure, and deploy AWS resources for third-party applications\n\t\t\t\t\t\twithout having to manually identify and provision individual AWS\n\t\t\t\t\t\tresources.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/systems-manager\">AWS Systems Manager</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Perform operations at scale on EC2 instances with this secure end-to-end\n\t\t\t\t\t\tmanagement solution.</p>\n\t\t\t\t</dd>\n\t\t\t</dl></div>\n\t\t\n\t\t<div class=\"variablelist\">\n\t\t\t<h6>Additional compute services</h6>\n\t\t\t<p>You can launch instances using another AWS compute service instead of using Amazon EC2.</p>\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t<dl>\n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/lightsail\">Amazon Lightsail</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Build websites or web applications using Amazon Lightsail, a cloud platform\n\t\t\t\t\t\tthat provides the resources that you need to deploy your project quickly, for\n\t\t\t\t\t\ta low, predictable monthly price. To compare Amazon EC2 and Lightsail, see \n\t\t\t\t\t\t<a href=\"https://docs.aws.amazon.com/decision-guides/latest/lightsail-or-ec2/lightsail-or-ec2.html\">Amazon Lightsail or Amazon EC2</a>.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/ecs\">Amazon Elastic Container Service (Amazon ECS)</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Deploy, manage, and scale containerized applications on a cluster of EC2\n\t\t\t\t\t\tinstances. For more information, see <a href=\"https://docs.aws.amazon.com/decision-guides/latest/containers-on-aws-how-to-choose/choosing-aws-container-service.html\">Choosing an AWS container service</a>.</p>\n\t\t\t\t</dd>\n\t\t\t \n\t\t\t\t<dt><span class=\"term\"><a href=\"https://docs.aws.amazon.com/eks\">Amazon Elastic Kubernetes Service (Amazon EKS)</a></span></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Run your Kubernetes applications on AWS.  For more information, see \n\t\t\t\t\t\t<a href=\"https://docs.aws.amazon.com/decision-guides/latest/containers-on-aws-how-to-choose/choosing-aws-container-service.html\">Choosing an AWS container service</a>.</p>\n\t\t\t\t</dd>\n\t\t\t</dl></div>\n\t \n\t\t<h2 id=\"access-ec2\">Access Amazon EC2</h2>\n\t\t<p>You can create and manage your Amazon EC2 instances using the following interfaces:</p>\n\n\t\t<div class=\"variablelist\">\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t<dl>\n\t\t\t\t<dt><b><span class=\"term\">Amazon EC2 console</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>A simple web interface to create and manage Amazon EC2 instances and resources.\n\t\t\t\t\t\tIf you've signed up for an AWS account, you can access the Amazon EC2 console\n\t\t\t\t\t\tby signing into the AWS Management Console and selecting <b>EC2</b> from\n\t\t\t\t\t\tthe console home page.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">AWS Command Line Interface</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Enables you to interact with AWS services using commands in your command-line shell. It\n\t\t\t\t\t\tis supported on Windows, Mac, and Linux. For more information about the\n\t\t\t\t\t\tAWS CLI , see <a href=\"https://docs.aws.amazon.com/cli/latest/userguide/\">AWS Command Line Interface User Guide</a>. You can find the Amazon EC2 commands in the <a href=\"https://docs.aws.amazon.com/cli/latest/reference/ec2/index.html\">AWS CLI Command Reference</a>.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">AWS Tools for PowerShell</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>A set of PowerShell modules that are built on the functionality exposed by\n\t\t\t\t\t\tthe AWS SDK for .NET. The Tools for PowerShell enable you to script operations on your AWS\n\t\t\t\t\t\tresources from the PowerShell command line. To get started, see the\n\t\t\t\t\t\t<a href=\"https://docs.aws.amazon.com/powershell/latest/userguide/\">AWS Tools for Windows PowerShell User Guide</a>. You can find the cmdlets for Amazon EC2, in the <a href=\"https://docs.aws.amazon.com/powershell/latest/reference/Index.html\">AWS Tools for PowerShell Cmdlet Reference</a>.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">AWS CloudFormation</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Amazon EC2 supports creating resources using AWS CloudFormation. You create a template, in JSON or YAML\n\t\t\t\t\t\tformat, that describes your AWS resources, and AWS CloudFormation provisions and\n\t\t\t\t\t\tconfigures those resources for you. You can reuse your CloudFormation\n\t\t\t\t\t\ttemplates to provision the same resources multiple times, whether in the\n\t\t\t\t\t\tsame Region and account or in multiple Regions and accounts. For more\n\t\t\t\t\t\tinformation about supported resource types and properties for Amazon EC2, see\n\t\t\t\t\t\t\t<a href=\"https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/AWS_EC2.html\">EC2 resource type\n\t\t\t\t\t\t\treference</a> in the <em>AWS CloudFormation User Guide</em>.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Query API</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Amazon EC2 provides a Query API. These requests are HTTP or HTTPS requests that\n\t\t\t\t\t\tuse the HTTP verbs GET or POST and a Query parameter named\n\t\t\t\t\t\t\t<code class=\"code\">Action</code>. For more information about the API actions for\n\t\t\t\t\t\tAmazon EC2, see <a href=\"https://docs.aws.amazon.com/AWSEC2/latest/APIReference/query-apis.html\">Actions</a> in the\n\t\t\t\t\t\t\t<em>Amazon EC2 API Reference</em>.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">AWS SDKs</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>If you prefer to build applications using language-specific APIs instead\n\t\t\t\t\t\tof submitting a request over HTTP or HTTPS, AWS provides libraries, sample\n\t\t\t\t\t\tcode, tutorials, and other resources for software developers. These\n\t\t\t\t\t\tlibraries provide basic functions that automate tasks such as\n\t\t\t\t\t\tcryptographically signing your requests, retrying requests, and handling\n\t\t\t\t\t\terror responses, making it easier for you to get started. For more\n\t\t\t\t\t\tinformation, see \n\t\t\t\t\t\t<span><a href=\"https://aws.amazon.com/tools/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>Tools to Build\n\t\t\t\t\t\t\t\ton AWS</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a></span>.</p>\n\t\t\t\t</dd>\n\t\t\t</dl></div>\n\t \n\t\t<h2 id=\"ec2-pricing\">Pricing for Amazon EC2</h2>\n\t\t<p>Amazon EC2 provides the following pricing options:</p>\n\t\t<div class=\"variablelist\">\n\n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t\t \n\t\t<dl>\n\t\t\t\t<dt><b><span class=\"term\">Free Tier</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>You can get started with Amazon EC2 for free. To explore the Free Tier options,\n\t\t\t\t\t\tsee <a href=\"https://aws.amazon.com/free\" rel=\"noopener noreferrer\" target=\"_blank\"><span>AWS Free Tier</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">On-Demand Instances</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Pay for the instances that you use by the second, with a minimum of 60\n\t\t\t\t\t\tseconds, with no long-term commitments or upfront payments.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Savings Plans</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>You can reduce your Amazon EC2 costs by making a commitment to a consistent\n\t\t\t\t\t\tamount of usage, in USD per hour, for a term of 1 or 3 years.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Reserved Instances</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>You can reduce your Amazon EC2 costs by making a commitment to a specific\n\t\t\t\t\t\tinstance configuration, including instance type and Region, for a term of 1\n\t\t\t\t\t\tor 3 years.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Spot Instances</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Request unused EC2 instances, which can reduce your Amazon EC2 costs\n\t\t\t\t\t\tsignificantly.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Dedicated Hosts</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Reduce costs by using a physical EC2 server that is fully dedicated for\n\t\t\t\t\t\tyour use, either On-Demand or as part of a Savings Plan. You can use your\n\t\t\t\t\t\texisting server-bound software licenses and get help meeting compliance\n\t\t\t\t\t\trequirements. </p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">On-Demand Capacity Reservations</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Reserve compute capacity for your EC2 instances in a specific Availability\n\t\t\t\t\t\tZone for any duration of time.</p>\n\t\t\t\t</dd>\n\t\t\t\n\t\t\t\t<dt><b><span class=\"term\">Per-second billing</span></b></dt>\n\t\t\t\t<dd>\n\t\t\t\t\t<p>Removes the cost of unused minutes and seconds from your bill.</p>\n\t\t\t\t</dd>\n\t\t\t</dl></div>\n\t\t<p>For a complete list of charges and prices for Amazon EC2 and more information about the purchase\n\t\t\tmodels, see <a href=\"https://aws.amazon.com/ec2/pricing\" rel=\"noopener noreferrer\" target=\"_blank\"><span>Amazon EC2 pricing</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\t\t \n\t\t\t<h3 id=\"ec2-pricing-additional\">Estimates, billing, and cost\n\t\t\t\t\toptimization</h3>\n\t\t\t<p>To create estimates for your AWS use cases, use the <a href=\"https://calculator.aws/#/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>AWS Pricing Calculator</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\t\t\t\n\t\t\t<p>To see your bill, go to the <b>Billing and Cost Management\n\t\t\t\t\tDashboard</b> in the <a href=\"https://console.aws.amazon.com/billing/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>AWS Billing and Cost Management\n\t\t\t\t\tconsole</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>. Your bill contains links to usage reports that provide details\n\t\t\t\tabout your bill. To learn more about AWS account billing, see <a href=\"https://docs.aws.amazon.com/awsaccountbilling/latest/aboutv2/\">AWS Billing and Cost Management User\n\t\t\t\tGuide</a>.</p>\n\t\t\t<p>If you have questions concerning AWS billing, accounts, and events, <a href=\"https://aws.amazon.com/contact-us/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>contact AWS Support</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\t\t\t<p><span>To calculate the cost of a sample provisioned\n\t\t\t\t\tenvironment, see <a href=\"https://aws.amazon.com/economics/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>Cloud Economics\n\t\t\t\t\t\tCenter</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</span> When calculating the cost of a provisioned\n\t\t\t\tenvironment, remember to include incidental costs such as snapshot storage for EBS\n\t\t\t\tvolumes. </p>\n\t\t\t<p>You can optimize the cost, security, and performance of your AWS environment\n\t\t\t\tusing <a href=\"https://aws.amazon.com/premiumsupport/technology/trusted-advisor/\" rel=\"noopener noreferrer\" target=\"_blank\"><span>AWS Trusted Advisor</span><awsui-icon class=\"awsdocs-link-icon\" name=\"external\"></awsui-icon></a>.</p>\n\t\t \n\t<awsdocs-copyright class=\"copyright-print\"></awsdocs-copyright><awsdocs-thumb-feedback right-edge=\"{{$ctrl.thumbFeedbackRightEdge}}\"></awsdocs-thumb-feedback></div><noscript><div><div><div><div id=\"js_error_message\"><p><img src=\"https://d1ge0kk1l5kms0.cloudfront.net/images/G/01/webservices/console/warning.png\" alt=\"Warning\" /> <strong>Javascript is disabled or is unavailable in your browser.</strong></p><p>To use the Amazon Web Services Documentation, Javascript must be enabled. Please refer to your browser's Help pages for instructions.</p></div></div></div></div></noscript><div id=\"main-col-footer\" class=\"awsui-util-font-size-0\"><div id=\"doc-conventions\"><a target=\"_top\" href=\"/general/latest/gr/docconventions.html\">Document Conventions</a></div><div class=\"prev-next\"><div id=\"next\" class=\"next-link\" accesskey=\"n\" href=\"./get-set-up-for-amazon-ec2.html\">Set up</div></div></div><awsdocs-page-utilities></awsdocs-page-utilities></div><div id=\"quick-feedback-yes\" style=\"display: none;\"><div class=\"title\">Did this page help you? - Yes</div><div class=\"content\"><p>Thanks for letting us know we're doing a good job!</p><p>If you've got a moment, please tell us what we did right so we can do more of it.</p><p><awsui-button id=\"fblink\" rel=\"noopener noreferrer\" target=\"_blank\" text=\"Feedback\" click=\"linkClick($event)\" href=\"https://docs.aws.amazon.com/forms/aws-doc-feedback?hidden_service_name=EC2&amp;topic_url=https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/concepts.html\"></awsui-button></p></div></div><div id=\"quick-feedback-no\" style=\"display: none;\"><div class=\"title\">Did this page help you? - No</div><div class=\"content\"><p>Thanks for letting us know this page needs work. We're sorry we let you down.</p><p>If you've got a moment, please tell us how we can make the documentation better.</p><p><awsui-button id=\"fblink\" rel=\"noopener noreferrer\" target=\"_blank\" text=\"Feedback\" click=\"linkClick($event)\" href=\"https://docs.aws.amazon.com/forms/aws-doc-feedback?hidden_service_name=EC2&amp;topic_url=https://docs.aws.amazon.com/en_us/AWSEC2/latest/UserGuide/concepts.html\"></awsui-button></p></div></div></div></body></div></awsdocs-view><div class=\"page-loading-indicator\" id=\"page-loading-indicator\"><awsui-spinner size=\"large\"></awsui-spinner></div></div><div id=\"tools-panel\" dom-region=\"tools\"><awsdocs-tools-panel id=\"awsdocs-tools-panel\"></awsdocs-tools-panel></div></awsui-app-layout><awsdocs-cookie-banner class=\"doc-cookie-banner\"></awsdocs-cookie-banner></div></body></html>"
  }
}
```

---

## Customer Support

Need any assistance? [Get in touch with Customer Support](https://apiverve.com/contact).

---

## Updates
Stay up to date by following [@apiverveHQ](https://twitter.com/apiverveHQ) on Twitter.

---

## Legal

All usage of the APIVerve website, API, and services is subject to the [APIVerve Terms of Service](https://apiverve.com/terms) and all legal documents and agreements.

---

## License
Licensed under the The MIT License (MIT)

Copyright (&copy;) 2024 APIVerve, and Evlar LLC

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.